// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;
using Hiperscan.ApoIdentCommon.ApoConfig;

namespace Hiperscan.ApoIdentCore
{
    public partial class AppControl
    {
        public void SaveConfig()
        {
            try
            {
                this.Config.SafetyWrite(this.FileSystem.ConfigFile);
            }
            catch (Exception ex)
            {
                Console.WriteLine("Cannot save last used ip address: {0}", ex);
            }
        }

        public void StashSettings()
        {
            this.Config.StashAll();
        }

        public void UnstashSettings()
        {
            this.Config.UnstashAll();
        }

        public GuiSettings GuiSettings => this.Config.GuiSettings;

        public LabelPrinterSettings LabelPrinterSettings
        {
            get
            {
                return this.Config.LabelPrinterSettings;
            }
        }

        public ProfileManager ProfileManager
        {
            get
            {
                return this.Config.Profiles;
            }
        }

        public IdentModuleSettings IdentModuleSettings
        {
            get
            {
                return this.Config.IdentModuleSettings;
            }
        }

        public QuantifierModuleSettings QuantifierModuleSettings
        {
            get
            {
                return this.Config.QuantifierModuleSettings;
            }
        }

        public DeviceSettings DeviceSettings
        {
            get
            {
                return this.Config.DeviceSettings;
            }
        }

        public SoftwareUpgradeSettings SoftwareUpgradeSettings
        {
            get
            {
                return this.Config.SoftwareUpgradeSettings;
            }
        }

        private Configurations Config { get;  set; }
    }
}
